/*
jQueryのプラグイン：テキストハイライトデザイナ
コードをカラーリングするプラグインで、商用利用も改変も自由のオープンソースです。
このコメントは削除して使ってね！
尚、このコードを使って損害が出ても作成者は責任を負いません。
予めご了承ください。
ver.1.0.0.0
*/
const array_thd = [
    { "text" : "int",       "color" : "#ff0000"},
    { "text" : "class",     "color" : "#3a5c8f"},
    { "text" : "static",    "color" : "#daa520"},
    { "text" : "public",    "color" : "#5c60c0"},
    { "text" : "function",  "color" : "#2a0fa6"},
    { "text" : "string",    "color" : "#2aaf26"},
    { "text" : "void",      "color" : "#008080"},
    { "text" : "var",       "color" : "#8ac0ff"},
    { "text" : "const",     "color" : "#ffff00"},
    { "text" : "if",        "color" : "#1e90ff"},
    { "text" : "else",      "color" : "#1ec0cf"},
    { "text" : "foreach",   "color" : "#8e90ff"},
    { "text" : "for",       "color" : "#8e90ff"},
    { "text" : "&#91;",     "color" : "#8490cf"},
    { "text" : "&#93;",     "color" : "#8490cf"},
    { "text" : "return",    "color" : "#af00af"},
    { "text" : "&plus;",    "color" : "#ff3333"},
    { "text" : "&#x2D;",    "color" : "#3388ff"}
];

// ネストされたカッコのカラー
const txcolor = new Array("#66f", "#008", "#3aa", "#00f", "#004","#aaf", "#55a", "#c0c", "#fac", "#f63");

// ダブルクォーテーションまたはシングルクォーテーションで囲まれた文字列の色
const dquote_color = "#c42";
const squote_color = "#882";

$(function() {
    var elem = $('.code');
    elem.each(function (index, element) {
        //Code Replace
        $cr = $(this).text();
        $(this).html('');

        $(this).prepend('<div class=\"code_data\"></div>');
        $(this).prepend('<div class=\"code_row_num\"></div>');

        // リテラル
        $cr = $cr.replace(/\r|\n|\r\n/, ''); // 最初の改行を削除
        $cr = $cr.replace(/ /g, '&nbsp;');
        $cr = $cr.replace(/\</g, '&lt;');
        $cr = $cr.replace(/\>/g, '&gt;');
        $cr = $cr.replace(/\"/g, '&quot;');
        $cr = $cr.replace(/\'/g, '&#39;');
        $cr = $cr.replace(/\[/g, '&#91;');
        $cr = $cr.replace(/\]/g, '&#93;');
        $cr = $cr.replace(/\+/g, '&plus;');
        $cr = $cr.replace(/\-/g, '&#x2D;');
        $cr = $cr.replace(/\r|\n|\r\n/g, '<br1>');

        $cr = quotes_color($cr, '&quot;');
        $cr = quotes_color($cr, '&#39;');

        // コードハイライト
        $.each(array_thd,
            function(index, elem) {
                $cr = text_highlight($cr, elem.text, elem.color);
            }
        );

        $cr = parenthesis_color($cr);
        $cr = braces_color($cr);        

        // コード
        $lines = $cr.split('<br1>');
        $code_data = "";
        for ($i = 0; $i < $lines.length; $i++ ) {
            if($i + 1 != $lines.length ) {
                if($lines[$i] != '') {
                    $code_data += '<span>' + $lines[$i] + '</span><br1>';
                } else {
                    $code_data += '<span><br></span><br1>';
                }
            }
        }
        $(this).find('.code_data').html($code_data.replace(/<br1>/g, '\n'));

        // 行番号
        $code_row_num = $code_data.match(/<br1>/g).length;
        for($i = 1; $code_row_num >= $i; $i++) {
            $(this).find('.code_row_num').append('<span>' + $i + '</span>');
        }
    });
});

function text_highlight($code, $literal, $color) {
    return $code.replace(new RegExp($literal,'g'), '<span style=\"color:' + $color + '\">' + $literal + '</span>');
}

var color_index = 0;
var index_array = new Array();

function parenthesis_color(str_code) {
    color_index = 0;
    index_array = [0, 'left'];

    for(var i = 0; i <= 50; i++)
    {
        index_array[0] = index_array[0] + 1;
        index_array = nextParenthesis(str_code, index_array[0]);

        if(index_array[0] != -1)
        {
            if(index_array[1] == 'left')
            {
                str_code = leftHighLight(str_code, index_array[0], color_index);
                color_index++;
            }
            else if(index_array[1] == 'right')
            {
                str_code = rightHighLight(str_code, index_array[0], color_index - 1);
                if(color_index != 0)
                {
                    color_index--;
                }
            }
        }
        else
        {
            break;
        }
    }
    return str_code;
}

// 次のカッコは左カッコ か 右カッコ か
function nextParenthesis(h_str_code, h_index) {
    var num_left = h_str_code.indexOf('(', h_index);
    var num_right= h_str_code.indexOf(')', h_index);
    
    if(num_left < num_right && num_left != -1)
    {
        return  [num_left, 'left'];
    }
    else
    {
        return [num_right, 'right'];
    }
}

function leftHighLight(h_str_code, h_left_index, h_color_index) {
    // '(' ハイライト
    highlight   = "<span style=\"color:" + txcolor[h_color_index] + "\">(</span>";
    before      = h_str_code.slice(0, h_left_index);
    after       = h_str_code.slice(h_left_index + 1, h_str_code.length);
    str_code    = before + highlight + after;

    index_array[0] = h_left_index + highlight.length - 1;
    return  str_code;
}

function rightHighLight(h_str_code, h_right_index, h_color_index) {
    // ')' ハイライト
    highlight   = "<span style=\"color:" + txcolor[h_color_index] + "\">)</span>";
    before      = h_str_code.slice(0, h_right_index);
    after       = h_str_code.slice(h_right_index + 1, h_str_code.length);
    str_code    = before + highlight + after;

    index_array[0] = h_right_index + highlight.length - 1;
    return str_code;
}

function braces_color(str_code) {
    color_index = 0;
    index_array = [0, 'left'];

    for(var i = 0; i <= 50; i++)
    {
        index_array[0] = index_array[0] + 1;
        index_array = nextBraces(str_code, index_array[0]);

        if(index_array[0] != -1)
        {
            if(index_array[1] == 'left')
            {
                str_code = leftHighLightBraces(str_code, index_array[0], color_index);
                color_index++;
            }
            else if(index_array[1] == 'right')
            {
                str_code = rightHighLightBraces(str_code, index_array[0], color_index - 1);
                if(color_index != 0)
                {
                    color_index--;
                }
            }
        }
        else
        {
            break;
        }
    }
    return str_code;
}

// 次の波カッコは左波カッコ か 右波カッコ か
function nextBraces(h_str_code, h_index) {
    var num_left = h_str_code.indexOf('{', h_index);
    var num_right= h_str_code.indexOf('}', h_index);
    
    if(num_left < num_right && num_left != -1)
    {
        return  [num_left, 'left'];
    }
    else
    {
        return [num_right, 'right'];
    }
}

function leftHighLightBraces(h_str_code, h_left_index, h_color_index) {
    // '{' ハイライト
    highlight   = "<span style=\"color:" + txcolor[h_color_index] + "\">{</span>";
    before      = h_str_code.slice(0, h_left_index);
    after       = h_str_code.slice(h_left_index + 1, h_str_code.length);
    str_code    = before + highlight + after;

    index_array[0] = h_left_index + highlight.length - 1;
    return  str_code;
}

function rightHighLightBraces(h_str_code, h_right_index, h_color_index) {
    // '}' ハイライト
    highlight   = "<span style=\"color:" + txcolor[h_color_index] + "\">}</span>";
    before      = h_str_code.slice(0, h_right_index);
    after       = h_str_code.slice(h_right_index + 1, h_str_code.length);
    str_code    = before + highlight + after;

    index_array[0] = h_right_index + highlight.length - 1;
    return str_code;
}

function quotes_color(h_str_code , h_str_q) {
    var switch_flg = true;
    h_index = 0;

    if(h_str_q == "&quot;")
    {
        quote_color = dquote_color;
    }
    else
    {
        quote_color = squote_color;
    }
    
    for(var i = 0; i <= 50; i++){
        h_index = h_str_code.indexOf(h_str_q , h_index);

        if(h_index == -1) return h_str_code;

        if(switch_flg == true)
        {
            highlight   = "<span style=\"color:" + quote_color + "\">";
            before      = h_str_code.slice(0, h_index);
            after       = h_str_code.slice(h_index, h_str_code.length);
            h_str_code  = before + highlight + after;
            h_index     = h_index + highlight.length + 1;
            switch_flg  = false;
        }
        else
        {
            span        = "</span>";
            before      = h_str_code.slice(0, h_index + h_str_q.length);
            after       = h_str_code.slice(h_index + h_str_q.length, h_str_code.length);
            h_str_code  = before + span + after;
            h_index     = h_index + span.length + 1;
            switch_flg  = true;
        }
    }
    return h_str_code;
}